package com.gic.enterprise.jsonSeralizer;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;

import java.io.IOException;

public abstract class AbstractJsonSerializer extends JsonSerializer<String> {

    protected abstract String serializerData(String value);

    @Override
    public void serialize(String o, JsonGenerator jsonGenerator, SerializerProvider serializerProvider) throws IOException, JsonProcessingException {
        if(o != null){
            String result = this.serializerData(o);
            jsonGenerator.writeString(result);
        }
    }
}
